/*
 * SNAKE
 * Very basic example of the snake game.
 * by Guillermo Sampallo - 2019
 * www.gsampallo.com
 */
package app;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.*;
import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Font;

import javax.swing.JFrame;
import javax.swing.JPanel;

import java.util.ArrayList;
import java.util.Random;

public class Snake extends JFrame {
    
    ImagenSnake imagenSnake;

    int widthPoint = 10;
    int heightPoint = 10;

    boolean gameOver = false;
	String direccion = "RIGHT";
	long frequency = 50;
    Point snake;

    int longitud = 2;

    int width = 640;
    int height = 480;


    public Snake() {
		setTitle("Snake");

        snake = new Point(320,240);
        imagenSnake = new ImagenSnake();

        this.getContentPane().add(imagenSnake);

		setSize(width,height);
		
		this.addKeyListener(new Teclas());
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JFrame.setDefaultLookAndFeelDecorated(false);
		setUndecorated(true);
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		this.setLocation(dim.width/2-this.getSize().width/2, dim.height/2-this.getSize().height/2);

        setVisible(true);

        startGame();

        Momento momento = new Momento();
		Thread trid = new Thread(momento);
		trid.start();
    }


	public static void main(String[] args) {
		Snake snake1 = new Snake();
	}

    public class ImagenSnake extends JPanel {
        public void paintComponent(Graphics g) {
            super.paintComponent(g);

            g.setColor(new Color(0,0,255));
    
            g.fillRect(snake.x,snake.y,widthPoint,heightPoint);

            g.setColor(new Color(255,0,0));
            g.fillRect(comida.x,comida.y,widthPoint,heightPoint);   
        }
    }

    public void startGame() {
		comida = new Point(200,100);	
        snake = new Point(320,240);        
    }
    public void actualizar() {
        if((snake.x > (comida.x-10) && snake.x < (comida.x+10)) && (snake.y > (comida.y-10) && snake.y < (comida.y+10))) {
            generarComida();
        }        
        imagenSnake.repaint();

    }

    Point comida;
    public void generarComida() {
        Random rnd = new Random();
        
        comida.x = (rnd.nextInt(width)) + 5;
        if((comida.x % 5) > 0) {
            comida.x = comida.x - (comida.x % 5);
        }

        if(comida.x < 5) {
            comida.x = comida.x + 10;
        }
        if(comida.x > width) {
            comida.x = comida.x - 10;
        }

        comida.y = (rnd.nextInt(height)) + 5;
        if((comida.y % 5) > 0) {
            comida.y = comida.y - (comida.y % 5);
        }	

        if(comida.y > height) {
            comida.y = comida.y - 10;
        }
        if(comida.y < 0) {
            comida.y = comida.y + 10;
        }

    }

	public class Teclas extends java.awt.event.KeyAdapter {
		@Override
		public void keyPressed(KeyEvent e) {

			if(e.getKeyCode() == KeyEvent.VK_ESCAPE) {
                System.exit(0);			
			} else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {

				if(direccion != "LEFT") {
                    direccion = "RIGHT";

				}
			} else if(e.getKeyCode() == KeyEvent.VK_LEFT) {
				if(direccion != "RIGHT") {
                    direccion = "LEFT";
				}
			} else if(e.getKeyCode() == KeyEvent.VK_UP) {
				if(direccion != "DOWN") {
                    direccion = "UP";
				}
			} else if(e.getKeyCode() == KeyEvent.VK_DOWN) {
				if(direccion != "UP") {
                    direccion = "DOWN";
				}                
			}
		}

	}

	public class Momento extends Thread {
		
		private long last = 0;
		
		public Momento() {
			
		}

		public void run() {
			while(true) {
				if((java.lang.System.currentTimeMillis() - last) > frequency) {
					if(!gameOver) {

                        if(direccion == "RIGHT") {
                            snake.x = snake.x + widthPoint;
                            if(snake.x > width) {
                                snake.x = 0;
                            }
                        } else if(direccion == "LEFT") {
                            snake.x = snake.x - widthPoint;
                            if(snake.x < 0) {
                                snake.x = width - widthPoint;
                            }                        
                        } else if(direccion == "UP") {
                            snake.y = snake.y - heightPoint;
                            if(snake.y < 0) {
                                snake.y = height;
                            }                        
                        } else if(direccion == "DOWN") {
                            snake.y = snake.y + heightPoint;
                            if(snake.y > height) {
                                snake.y = 0;
                            }                        
                        }
                    }
                    actualizar();
					
					last = java.lang.System.currentTimeMillis();
				}
			}
		}
	}	
}